---
title: WebGLRenderingContext.getVertexAttrib()
slug: Web/API/WebGLRenderingContext/getVertexAttrib
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.getVertexAttrib()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> returns information about a vertex attribute at a given position.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">any <var>gl</var>.getVertexAttrib(<var>index</var>, <var>pname</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>index</code></dt>
 <dd>A {{domxref("GLuint")}} specifying the index of the vertex attribute.</dd>
 <dt><code>pname</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the information to query. Possible values:
 <ul>
  <li><code>gl.VERTEX_ATTRIB_ARRAY_BUFFER_BINDING</code>: Returns the currently bound {{domxref("WebGLBuffer")}}.</li>
  <li><code>gl.VERTEX_ATTRIB_ARRAY_ENABLED</code>: Returns a {{domxref("GLboolean")}} that is <code>true</code> if the vertex attribute is enabled at this <code>index</code>. Otherwise <code>false</code>.</li>
  <li><code>gl.VERTEX_ATTRIB_ARRAY_SIZE</code>: Returns a {{domxref("GLint")}} indicating the size of an element of the vertex array.</li>
  <li><code>gl.VERTEX_ATTRIB_ARRAY_STRIDE</code>: Returns a {{domxref("GLint")}} indicating the number of bytes between successive elements in the array. 0 means that the elements are sequential.</li>
  <li><code>gl.VERTEX_ATTRIB_ARRAY_TYPE</code>: Returns a {{domxref("GLenum")}} representing the array type. One of
   <ul>
    <li><code>gl.BYTE</code>,</li>
    <li><code>gl.UNSIGNED_BYTE</code>,</li>
    <li><code>gl.SHORT</code>,</li>
    <li><code>gl.UNSIGNED_SHORT</code>,</li>
    <li><code>gl.FLOAT</code>.</li>
   </ul>
  </li>
  <li><code>gl.VERTEX_ATTRIB_ARRAY_NORMALIZED</code>: Returns a {{domxref("GLboolean")}} that is true if fixed-point data types are normalized for the vertex attribute array at the given <code>index</code>.</li>
  <li><code>gl.CURRENT_VERTEX_ATTRIB</code>: Returns a {{jsxref("Float32Array")}} (with 4 elements) representing the current value of the vertex attribute at the given <code>index</code>.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.VERTEX_ATTRIB_ARRAY_INTEGER</code>: Returns a {{domxref("GLboolean")}} indicating whether or not an integer data type is in the vertex attribute array at the given <code>index</code>.</li>
    <li><code>gl.VERTEX_ATTRIB_ARRAY_DIVISOR</code>: Returns a {{domxref("GLint")}} describing the frequency divisor used for instanced rendering.</li>
   </ul>
  </li>
  <li>When using the {{domxref("ANGLE_instanced_arrays")}} extension:
   <ul>
    <li><code>ext.VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE</code>: Returns a {{domxref("GLint")}} describing the frequency divisor used for instanced rendering.</li>
   </ul>
  </li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Returns the requested vertex attribute information (as specified with <code>pname</code>).</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.getVertexAttrib(0, gl.VERTEX_ATTRIB_ARRAY_BUFFER_BINDING);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.10", "getVertexAttrib")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glGetVertexAttrib.xml", "glGetVertexAttrib")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL ES 2 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.8", "getVertexAttrib")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL 2.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glGetVertexAttrib.xhtml", "glGetVertexAttrib")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the OpenGL ES 3 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.getVertexAttrib")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getVertexAttribOffset()")}}</li>
 <li>{{domxref("ANGLE_instanced_arrays")}}</li>
</ul>
